#! /bin/sh
#
# MySQL dump Debian System Maintainer felhasznaloval
# Ezt a scriptet rootkent kell futtatni!
#
# Usage: mysql_dump.sh [backup_dir [backup_owner]]
#
# Eredeti valtozat: hornyak.alex@mimoza.hu
# Modositva: kovacs.zoltan@mimoza.hu 2005-05-06

compress="-c"			# Kommentezd, ha nem kell tomoriteni

datetime=`date +%Y%m%d%H%M%S`
echo "Started at  $datetime"

# Opcionalis parameter a keszulo backup pathname
# Alapertelmezes az aktualis konyvtar alatt, egyedi nevvel
bkuppath=${1:-`pwd`/$datetime}; shift

# Opcionalis parameter a keszulo backup birtokosa 
# Alapertelemezes a "backup" felhasznalo
dumpuser=${1:-"backup"}; shift
dumpdirgroup="disk"

mysql_dsm="/usr/bin/mysql --defaults-file=/etc/mysql/debian.cnf"
mysqldump_dsm="/usr/local/sbin/mysql_dumpdb.sh"
dblist=`$mysql_dsm --batch --execute='show databases;' | sed "s/^Database$//"`

# Backup konyvtar letrehozatala, ha szukseges; elozo backup torlese
if [ ! -d $bkuppath ]; then 
    mkdir -m 2750 $bkuppath; chown $dumpuser:$dumpdirgroup $bkuppath
else 
    rm $bkuppath/* 
fi
		    
# Dump adatbazisonkent kulon file-ba, altalaban tomoritve

for dbname in $dblist
do
    filename="$bkuppath/`hostname`.$datetime.$dbname.sql"
    $mysqldump_dsm $compress $dbname $filename $dumpuser
done

echo "Finished at "`date +%Y%m%d%H%M%S`
