#! /bin/sh
#
# MySQL adatbazis dump Debian System Maintainer felhasznaloval
#
# Eredeti valtozat: hornyak.alex@mimoza.hu
# Modositva: kovacs.zoltan@mimoza.hu 2005-05-06

EXIT_ERR="1"

# Ezt a scriptet rootkent kell futtatni!
if [ ! $UID -eq 0 ]; then
    echo "Run as root, please." >&2
    exit $EXIT_ERR
fi

# Opcionalis tomorites kapcsolo felvetele
option=`echo $1 | sed -n "s/^-\+//p"`; if [ ! -z "$option" ]; then shift; fi
if [ "$option" = "c" -o "$option" = "compress" ]; then 
    compress="/bin/gzip"
else 
    compress="cat"
fi

# Kotelezo parameter a dump-olando adatbazis neve
database=${1?"Usage: $0 [-c|--compress] database [backup_path|- [dump_user]]"};shift

# Opcionalis parameter a keszulo backup pathname
# Alapertelmezes az aktualis konyvtarban, egyedi nevvel
# Kiterjesztes igazitasa, ha tomorites elo van irva
# Ertelmezi a "-" pathname-et, ez esetben a stdout-ra ir.
filename=${1:-`pwd`/`hostname`.`date +%Y%m%d%H%M%S`.$database.sql}; shift
if [ "$filename" = "-" ]; then
    filename=""
else
    case "${compress##*/}" in
        "gzip")
	    filename="${filename%.gz}.gz"
	;;
    esac
fi

# Opcionalis parameter a keszulo backup birtokosa 
# Alapertelemezes a "backup" felhasznalo
dumpuser=${1:-"backup"}; shift

dumpfilerights="640"

mysql_dsm="/usr/bin/mysql --defaults-file=/etc/mysql/debian.cnf"
mysqldump_dsm="/usr/bin/mysqldump --defaults-file=/etc/mysql/debian.cnf"
# MySQL 4.x tarolt eljarasok nelkul
#dumpparameters="--all --databases --complete-insert --add-drop-table --extended-insert"
# MySQL 5.x tarolt eljarasokkal
dumpparameters="--all --databases --complete-insert --add-drop-table --extended-insert --routines"

# Ellenorizzuk, hogy a megadott adatbazis letezik-e - ha nem, hibauzenettel vege
if [ -z "`$mysql_dsm --batch --execute='show databases;' | \
          sed s/^Database$// | \
	  sed -n s/^$database$/X/p`" ]; then
    echo "MySQL database \"$database\" isn't found." >&2
    exit $EXIT_ERR
fi

# Elozo backup torlese, ha szukseges es maga a dump
if [ -f "$filename" ]; then rm $filename; fi
if [ ! -z "$filename" ]; then
    $mysqldump_dsm $dumpparameters $database | $compress >$filename
    chown $dumpuser $filename; chmod $dumpfilerights $filename
else
    $mysqldump_dsm $dumpparameters $database | $compress
fi

# Vege